#ifdef _WIN_IOT
// For communicating to C++/CX
#undef boolean
#define boolean bool
#endif

#define MAX_LEN 512
unsigned int data[MAX_LEN];
int dataPos;

// --------------
#define SERIAL_SPEED 115200

const int modulePin = GPIO_17;
const long waitMicros = 1000000;

unsigned long now, lastMicros;
int moduleStatus, totalMS;

void setup() {
	Serial.begin(SERIAL_SPEED);

	pinMode(modulePin, INPUT);

	now = micros();
	lastMicros = micros();
	moduleStatus = HIGH;

	dataPos = 0;
	totalMS = 0;
}

boolean waitSignal()
{
	unsigned long waitStartMicros = micros();
	while (digitalRead(modulePin) == moduleStatus) {
		if (micros() - waitStartMicros > waitMicros) return true;
		delayMicroseconds(100);
	}
	return false;
}

void loop() {
	if (dataPos >= MAX_LEN || waitSignal() == true) {
		if (totalMS > 4000) {	//45msec
			for (int i = 0; i < dataPos; i++) {
				Serial.print(data[i], DEC);
				Serial.print(",");
			}
			Serial.println();

			dataPos = 0;
			totalMS = 0;
		}
		return;
	}

	now = micros();

	int sc = (now - lastMicros) / 10;
	if (dataPos > 0) totalMS += sc;
	data[dataPos++] = sc;

	lastMicros = now;

	moduleStatus = !moduleStatus;
}
